// uses the HMC6352 compass sensor
#include <Wire.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

// HMC6352 Address is 0x42;
int SensoAddress;
byte headingDataMSB;
byte headingDataLSB;
int heading;
int headingdata;

void setup() {
  SensoAddress = 0x42 >> 1; //Library only needs 7 most significant bits (makes 0x21 as address) 
  Serial.begin(9600);
  Wire.begin();
  lcd.begin(16, 2);
}

void loop() {
  // send "a" command to HMC6352, this starts transmission
  
  Wire.beginTransmission(SensoAddress);
  Wire.write("A");
  Wire.endTransmission();
  delay(9); // sensor needs about 70µs delay
  
  // now requesting data!
  Wire.requestFrom(SensoAddress, 2); // requesting 2 bytes data, MSB comes first, 16 bit data
  
  while(Wire.available() > 0) { // first byte is msb, second is lsb
    headingDataMSB = Wire.read();
    headingDataLSB = Wire.read();
  }
  
  heading = headingDataMSB*256 + headingDataLSB; // Multiplication by 256 makes a 16 bit integer
  headingdata =  int (heading / 10);
  Serial.println(headingdata);

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Heading:");
  lcd.setCursor(0,1);
  lcd.print(headingdata);
  lcd.setCursor(6,1);
  lcd.print("degree"); 
}
