###############################################################
# by Johannes Kinzig                                          #
# PyCompass                                                   #
# reads in data from Arduino with Compass Module and          #
# displays the data graphical via tkinter and turtle         #
#                                                             #
# Version: 1.0                                                #
###############################################################

from turtle import *
import serial

###############################################################
#       Functions for the turtle graphics                    #
###############################################################

def Compass():
    hideturtle()
    tracer(0, 0) # switch off animation to build up compass fast!
    global compasspointer
    penup()
    right(90)
    forward(250)
    left(90)
    pendown()
    circle(250)
    penup()
    home()
    goto(260, 0)
    write("East", font=('Arial', 30, 'normal'), align="left")
    home()
    goto(0, 260)
    write("North", font = ('Arial', 30, 'normal'), align="center")
    home()
    goto(0, -290)
    write("South", font = ('Arial', 30, 'normal'), align="center")
    home()
    goto(-260, 0)
    write("West", font = ('Arial', 30, 'normal'), align="right")
    home()
    bgcolor("grey")
    compasspointer = Turtle()
    compasspointer.degrees(360) #make sure to use angle in degree, a circle has 360 degrees
    compasspointer.home()
    compasspointer.settiltangle(0)
    compasspointer.shape("triangle")
    compasspointer.color("blue")
    compasspointer.turtlesize(2, 15, 0)
    tracer(1, 1) # switch on animation, because compasspointer should turn
    compasspointer.speed(0)

###############################################################
#          Main programm Code                                 #
###############################################################

Arduino = serial.Serial("/dev/tty.usbmodemfd611", baudrate = 9600) # serial device
angle = 0

Compass()
while (True):
    
    try:
        angle = Arduino.readline()
        angle = angle.strip()
        angle = int(angle)
        compasspointer.settiltangle(-angle+90) #turtles' zero position is not North, its East. But 0 degree equals N. (+90)
                                                #Turtles' angle go counterclockwise, but we need it clockwise (-angle)
        #print angle
    
    except:
        pass










